<?php

// Perlメモ方式のファイルロック

function my_flock($options = array()){
    $lfh = array_merge(array('dir'      => './lockdir/',
                             'basename' => 'lockfile',
                             'timeout'  => 60,
                             'trytime'  => 10), $options);
    $lfh['path'] = $lfh['dir'] . $lfh['basename'];

    for ($i = 0; $i < $lfh['trytime']; $i++, sleep(1)) {
        if ( @rename($lfh['path'], $lfh['current'] = $lfh['path'] . time()) ) {
            return $lfh;
        }
    }
    $filelist = my_scandir($lfh['dir']);
    foreach ($filelist as $file) {
        if (preg_match('/^' . $lfh['basename'] . '(\d+)/', $file, $matches)) {
            if (time() - $matches[1] > $lfh['timeout']
              and rename($lfh['dir'] . $matches[0],
                         $lfh['current'] = $lfh['path'] . time())
            ) {
                return $lfh;
            }
            break;
        }
    }
    return false;
}


function my_funlock($lfh) {
    rename($lfh['current'], $lfh['path']);
}


function my_scandir($dir) {
	$dh  = opendir($dir);
	$files = array();
	while (false !== ($filename = readdir($dh))) {
		$files[] = $filename;
	}
	return $files;
}


function test_func(){

	//ロックする(タイムアウトあり)
	$lfh = my_flock() or die('Lock file Busy!');
	
		// read
		$filename = './data/output.txt';
		$rfp = fopen($filename,'r') or die("ファイル({$filename})のオープンに失敗しました");
		$line = fgets($rfp,1024);
		if (! $line){ $line=0;}
		$line++;
		fclose($rfp);
		
		print $line.'<br>';
		
		// write
		umask(0000);
		$tmp_filename = './data/'.getmypid().'.tmp';
		$fp = fopen($tmp_filename, 'w');
		fwrite($fp, $line);
		fclose( $fp );
		rename($tmp_filename, $filename);
		
	
	//アンロックする
	my_funlock($lfh);

	// 0.1秒sleep
	usleep(100000);

}

// テストを100回実行
for ($i=0;$i<100;$i++){
	test_func();
}



?>
